This document describes changes to the Apache HTTPD API from version 2.4
to 2.6, that may be of interest to module/application developers and
core hacks. As of the first GA release of the 2.6 branch API
compatibility is preserved for the life of the 2.6 branch. (The

VERSIONING

description for the 2.6 release provides more information about API
compatibility.)

API changes fall into two categories: APIs that are altogether new, and
existing APIs that are expanded or changed. The latter are further
divided into those where all changes are backwards-compatible (so
existing modules can ignore them), and those that might require
attention by maintainers. As with the transition from HTTPD 2.2 to 2.4,
existing modules and applications will require recompiling and may call
for some attention, but most should not require any substantial updating
(although some may be able to take advantage of API changes to offer
significant improvements).

For the purpose of this document, the API is split according to the
public header files. These headers are themselves the reference
documentation, and can be used to generate a browsable HTML reference
with

make docs

.

Changed APIs {#api_changes}
============

ap\_fill\_me\_in (NEW!) {#ap_fill_me_in}
-----------------------

Introduces a new API to fill me in.

Specific information on upgrading modules from 2.4 {#upgrading}
==================================================

Fill me in {#upgrading_fillmein}
----------

In order to take advantage of fill me in.

If your module uses these existing APIs\... {#upgrading_byfunction}
-------------------------------------------

ap\_md5digest()

/

ap\_md5contextTo64

These functions are no longer available. Use the equivalent functions
from APR if needed.

If your module interfaces with this feature\... {#upgrading_byfeature}
-----------------------------------------------

fillmin

Optional: If your module fills me in.

Does your module\... {#upgrading_newfeatures}
--------------------

Fill me in

Consider if filling me in.
