This document describes the use of Apache\'s Handlers.

What is a Handler {#definition}
=================

mod\_actions

mod\_asis

mod\_cgi

mod\_imagemap

mod\_info

mod\_mime

mod\_negotiation

mod\_status

Action

AddHandler

RemoveHandler

SetHandler

A \"handler\" is an internal Apache representation of the action to be
performed when a file is called. Generally, files have implicit
handlers, based on the file type. Normally, all files are simply served
by the server, but certain file types are \"handled\" separately.

Handlers may also be configured explicitly, based on either filename
extensions or on location, without relation to file type. This is
advantageous both because it is a more elegant solution, and because it
also allows for both a type

and

a handler to be associated with a file. (See also

Files with Multiple Extensions

.)

Handlers can either be built into the server or included in a module, or
they can be added with the

Action

directive. The built-in handlers in the standard distribution are as
follows:

default-handler

: Send the file using the

default\_handler()

, which is the handler used by default to handle static content. (core)

send-as-is

: Send file with HTTP headers as is. (

mod\_asis

)

cgi-script

: Treat the file as a CGI script. (

mod\_cgi

)

imap-file

: Parse as an imagemap rule file. (

mod\_imagemap

)

server-info

: Get the server\'s configuration information. (

mod\_info

)

server-status

: Get the server\'s status report. (

mod\_status

)

type-map

: Parse as a type map file for content negotiation. (

mod\_negotiation

)

Examples
========

Modifying static content using a CGI script {#example1}
-------------------------------------------

The following directives will cause requests for files with the

html

extension to trigger the launch of the

footer.pl

CGI script.

Action add-footer /cgi-bin/footer.pl AddHandler add-footer .html

Then the CGI script is responsible for sending the originally requested
document (pointed to by the

PATH\_TRANSLATED

environment variable) and making whatever modifications or additions are
desired.

Files with HTTP headers {#example2}
-----------------------

The following directives will enable the

send-as-is

handler, which is used for files which contain their own HTTP headers.
All files in the

/web/htdocs/asis/

directory will be processed by the

send-as-is

handler, regardless of their filename extensions.

\<Directory \"/web/htdocs/asis\"\> SetHandler send-as-is \</Directory\>

Programmer\'s Note {#programmer}
==================

In order to implement the handler features, an addition has been made to
the

Apache API

that you may wish to make use of. Specifically, a new record has been
added to the

request\_rec

structure:

char \*handler

If you wish to have your module engage a handler, you need only to set

r-\>handler

to the name of the handler at any time prior to the

invoke\_handler

stage of the request. Handlers are implemented as they were before,
albeit using the handler name instead of a content type. While it is not
necessary, the naming convention for handlers is to use a dash-separated
word, with no slashes, so as to not invade the media type name-space.
