mod\_cgid

Execution of CGI scripts using an external CGI daemon

Base

mod\_cgid.c

cgid\_module

Unix threaded MPMs only

Except for the optimizations and the additional

ScriptSock

directive noted below,

mod\_cgid

behaves similarly to

mod\_cgi

.

See the

mod\_cgi

summary for additional details about Apache and CGI.

On certain unix operating systems, forking a process from a
multi-threaded server is a very expensive operation because the new
process will replicate all the threads of the parent process. In order
to avoid incurring this expense on each CGI invocation,

mod\_cgid

creates an external daemon that is responsible for forking child
processes to run CGI scripts. The main server communicates with this
daemon using a unix domain socket.

This module is used by default instead of

mod\_cgi

whenever a multi-threaded MPM is selected during the compilation
process. At the user level, this module is identical in configuration
and operation to

mod\_cgi

. The only exception is the additional directive

ScriptSock

which gives the name of the socket to use for communication with the cgi
daemon.

mod\_cgi

Running CGI programs under different user IDs

ScriptLog

ScriptLogLength

ScriptLogBuffer

ScriptSock

The filename prefix of the socket to use for communication with the cgi
daemon

ScriptSock

file-path

ScriptSock cgisock

server config

This directive sets the filename prefix of the socket to use for
communication with the CGI daemon, an extension corresponding to the
process ID of the server will be appended. The socket will be opened
using the permissions of the user who starts Apache (usually root). To
maintain the security of communications with CGI scripts, it is
important that no other user has permission to write in the directory
where the socket is located.

If

file-path

is not an absolute path, the location specified will be relative to the
value of

DefaultRuntimeDir

.

ScriptSock /var/run/cgid.sock

CGIDScriptTimeout

The length of time to wait for more output from the CGI program

CGIDScriptTimeout

time

\[s\|ms\]

value of

Timeout

directive when unset or set to 0

server config

virtual host

directory

.htaccess

Available in httpd 2.4.10 and later; in prior releases no timeout was
applied

This directive limits the length of time to wait for more output from
the CGI program. If the time is exceeded, the request and CGI are
terminated.

CGIDScriptTimeout 20
