This is an index of the directives that are allowed in .htaccess files
for various

AllowOverride

settings, organized by class. Its intended purpose is to help server
administrators verify the privileges they\'re granting to .htaccess
users. For an overview of how .htaccess works, see the

.htaccess tutorial

.

To determine the set of directives that your server configuration allows
.htaccess users to use:

Start with the set of directives in the

AllowOverrideList

for the directory in question. (By default, this is set to

None

.)

Find the

AllowOverride

setting for the directory in question. (By default, it is set to

None

.) There are two special cases:

If your

AllowOverride

setting is

All

, add every directive listed on this page to the list.

If your

AllowOverride

setting is

None

, you\'re done. Only the directives in the

AllowOverrideList

(if any) will be allowed.

For each override class listed in

AllowOverride

, look up the corresponding set of directives below and add them to the
list.

Finally, add the set of directives that is always allowed in .htaccess
(these are listed in the

All section

, below).

Several of the override classes are quite powerful and give .htaccess
users a large amount of control over the server. For a stricter
approach, set

AllowOverride None

and use

AllowOverrideList

to specify the exact list of directives that .htaccess users are allowed
to use.

The following directives are allowed in any .htaccess file, as long as
overrides are enabled in the server configuration.

The following directives are allowed in .htaccess files when

AllowOverride AuthConfig

is in effect. They give .htaccess users control over the authentication
and authorization methods that are applied to their directory subtrees,
including several related utility directives for session handling and
TLS settings.

The following directives are allowed in .htaccess files when

AllowOverride FileInfo

is in effect. They give .htaccess users a wide range of control over the
responses and metadata given by the server.

The following directives are allowed in .htaccess files when

AllowOverride Indexes

is in effect. They allow .htaccess users to control aspects of the
directory index pages provided by the server, including autoindex
generation.

The following directives are allowed in .htaccess files when

AllowOverride Limit

is in effect. This extremely narrow override type mostly allows the use
of the legacy authorization directives provided by

mod\_access\_compat

.

The following directives are allowed in .htaccess files when

AllowOverride Options

is in effect. They give .htaccess users access to

Options

and similar directives, as well as directives that control the filter
chain.

\[This section has no description. It\'s possible that the documentation
is incomplete, or that the directives here have an incorrect or
misspelled Override type. Please consider reporting this in the

comments section

.\]
