This document describes some of the major changes between the 2.4 and
2.6 versions of the Apache HTTP Server. For new features since version
2.2, see the

2.4 new features

document.

Core Enhancements {#core}
=================

ContentDigest directive and Content-MD5 header

The

ContentDigest

directive and support for the the

Content-MD5

header has been removed from the server, corresponding with the removal
of this header from

RFC7231 Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content.

Listen

directive options

The

Listen

directive now supports an optional

options=\...

argument, allowing per-listener socket options to be configured.

systemd

socket activation

httpd

can now be configured to start via

systemd

socket activation

.

New

DefaultStateDir

directive.

The

DefaultStateDir

directive has been added to specify a directory for storing persistent
state.

Zone/scope support in IPv6 addresses

If built against APR 1.7.0 or later, zones (scopes) can be specified in
an IPv6 link-local address used with the

Listen

or

VirtualHost

directive.

New Modules {#newmods}
===========

mod\_journald

,

mod\_syslog

These new modules provide support for logging to syslog or

journald

.

Module Enhancements {#module}
===================

mod\_ssl

The following mod\_ssl enhancements are included:

SSLRandomSeed

directive is now deprecated and is ignored if building against OpenSSL
1.1.1 or later.

The

SSLKEYLOGFILE

environment variable can now be set to log private key material for
off-line decryption of SSL/TLS protocol dumps using third-party tools.

mod\_cgid

If configured with

\--enable-cgid-fdpassing

, the CGI daemon will set up stderr handling in the same way as
mod\_cgi.

Program Enhancements {#programs}
====================

htpasswd

The

htpasswd

utility can now generate SHA-256 or SHA-512

crypt()

hashes where supported by the C library.

Documentation
=============

Fill me in

The

mod\_example

documentation fill me in.

Module Developer Changes {#developer}
========================

New type

ap\_method\_mask\_t

.

The

ap\_method\_mask\_t

type has been added and is now used for the method\_mask field in
ap\_method\_list\_t, AP\_METHOD\_BIT, allowed field of request\_rec,
limited field of cmd\_parms.

mod\_ssl.h

mod\_ssl API changes.

The

ssl\_var\_lookup

optional function API now takes a

const char \*

name

argument and returns a

const char \*

string value. The pool argument must now be non-NULL.

The developer documentation contains a

detailed list of API changes

.
